<?php
/**
 * Description of MonkPanelCheckbox
 *
 * @author Ayrton De Craene (http://www.monkify.com)
 */
class MonkPanelCheckbox {
    private $title;
    private $description;
    private $optionId;
    private $value;

    public function __construct($title, $description, $optionId, $value = FALSE) {
        $this->title = $title;
        $this->description = $description;
        $this->optionId = $optionId;
        $this->value = $value;
    }

    public function getTitle() {
        return $this->title;
    }

    public function getDescription() {
        return $this->description;
    }

    public function getOptionId() {
        return $this->optionId;
    }

    public function getValue() {
        return $this->value;
    }

    public function __toString() {
        if(get_option($this->getOptionId())) {
            $checked = "checked=\"checked\"";
        }else {
            $checked = "";
        }
        global $monkpanel_dir;
        $checkbox = <<<EOD
<div class="monk_input monk_checkbox">
            <label for="$this->optionId">$this->title</label><div class="monk_info"><img src="$monkpanel_dir/images/information.png" alt="information" /><div class="bubble"><div class="bubble_btm"><div class="bubble_inner">
                    $this->description
                </div></div></div>
                </div>
            <input type="checkbox" name="$this->optionId" id="$this->optionId" value="true" $checked />            
</div>
EOD;
        return $checkbox;
    }

}
?>
