<?php
/**
 * Description of MonkPanelSelect
 *
 * @author Ayrton De Craene (http://www.monkify.com)
 */
class MonkPanelSelect {
    private $title;
    private $description;
    private $optionId;
    private $options;
    private $value; //default value

    function __construct($title, $description, $optionId, $options, $value) {
        $this->title = $title;
        $this->description = $description;
        $this->optionId = $optionId;
        $this->options = $options;
        $this->value = $value;
    }

    public function getTitle() {
        return $this->title;
    }

    public function getDescription() {
        return $this->description;
    }

    public function getOptionId() {
        return $this->optionId;
    }

    public function getOptions() {
        return $this->options;
    }

    public function getValue() {
        return $this->value;
    }
    public function __toString() {
        if ( get_settings( $this->optionId ) != "") {
            $value = stripslashes(get_settings( $this->optionId)  );
        } else {
            $value = $this->value;
        }

        foreach ($this->options as $selectOption) {
            $selects .= '<option ';
            if ($value == $selectOption) {
                $selects.= 'selected="selected"';
            }
            $selects .= '>'. $selectOption .'</option>';

        }
        global $monkpanel_dir;
        $select = <<<EOD
<div class="monk_input monk_select">
            <label for="$this->optionId">$this->title</label><div class="monk_info"><img src="$monkpanel_dir/images/information.png" alt="information" /><div class="bubble"><div class="bubble_btm"><div class="bubble_inner">
                $this->description
                </div></div></div>
                </div>
            <select name="$this->optionId" id="$this->optionId">
                $selects
            </select>            
</div>
EOD;
        return $select;
    }
}
?>
