<?php
/**
 * Description of MonkPanelText
 *
 * @author Ayrton De Craene (http://www.monkify.com)
 */
class MonkPanelText {
    private $title;
    private $description;
    private $optionId;
    private $value;
    private $isInputText;

    function __construct($title, $description, $optionId, $value,$isInputText = 'true') {
        $this->title = $title;
        $this->description = $description;
        $this->optionId = $optionId;
        $this->value = $value;
        $this->isInputText = $isInputText;
    }

    public function getTitle() {
        return $this->title;
    }

    public function getDescription() {
        return $this->description;
    }

    public function getOptionId() {
        return $this->optionId;
    }

    public function getValue() {
        return $this->value;
    }
    public function isInputText() {
        return $this->isInputText;
    }
    public function __toString() {
        if ( get_settings( $this->optionId ) != "") {
            $value = stripslashes(get_settings( $this->optionId)  );
        } else {
            $value = $this->value;
        }
global $monkpanel_dir;
if($this->isInputText) {

            $input ="<div class='monk_input monk_text'>
            <label for='$this->optionId'>$this->title</label><div class='monk_info'>";
            if(!is_bool($this->description)) {
                $input.="<img src='$monkpanel_dir/images/information.png' alt='information' /><div class='bubble'><div class='bubble_btm'><div class='bubble_inner'>
                        $this->description
                </div></div></div>";
            }
            $input.="</div>
            <input name='$this->optionId' id='$this->optionId' type='text' value='$value' />
</div>";
            return $input;
        }
        else {
            $textfield = "<div class='monk_input monk_textarea'>";
            $textfield .="<label for='$this->optionId'>$this->title</label><div class='monk_info'>";
            if(!is_bool($this->description)) {
                $textfield.="<img src='$monkpanel_dir/images/information.png' alt='information' /><div class='bubble'><div class='bubble_btm'><div class='bubble_inner'>
                        $this->description
                </div></div></div>";
            }
            $textfield .="</div><textarea name='$this->optionId' type='textarea' cols='' rows=''>$value</textarea></div>";

            return $textfield;
        }

    }
}
?>
