<?php
/*
 * @author Ayrton De Craene (http://www.monkify.com)
 * -> ayrton@monkify.com
*/

//get the theme options subpages and options
include_once 'monkPanelOptions.inc.php';

function mytheme_add_admin() {
    global $themename, $shortname, $subpages,$monkpanel_dir;

    if ($_GET['page'] == basename(__FILE__)) {
        if ('save' == $_REQUEST['action']) {
            foreach ($subpages[$_POST["monk_index"]]->getTabs() as $monk_tab) {
                foreach ($monk_tab->getSections() as $section) {
                    foreach ($section->getElements() as $option) {
                        $pageOptions[] = $option;
                    }
                }
            }

            foreach ($pageOptions as $option) {
                if (isset($_REQUEST[$option->getOptionId()])) {
                    update_option($option->getOptionId(), $_REQUEST[$option->getOptionId()]);
                } else {
                    delete_option($option->getOptionId());
                }
            }


            header("Location: admin.php?page=functions.php&saved=true");
            die;
        } elseif ('reset' == $_REQUEST['action']) {
            foreach ($subpages[$_POST["monk_index"]]->getTabs() as $monk_tab) {
                foreach ($monk_tab->getSections() as $section) {
                    foreach ($section->getElements() as $option) {
                        $pageOptions[] = $option;
                    }
                }
            }

            foreach ($pageOptions as $option) {
                delete_option($option->getOptionId());
            }

            header("Location: admin.php?page=functions.php&reset=true");
            die;
        }
    }

    add_menu_page($themename, $themename, 'administrator', basename(__FILE__), 'mytheme_admin', $monkpanel_dir .'/images/monk.png');
}

function mytheme_add_init() {
    global $themeversion, $allOptions,$monkpanel_dir;
    wp_enqueue_style("functions", $monkpanel_dir . "/css/style.css", false, $themeversion, "all");
    wp_enqueue_script("fh_script", $monkpanel_dir . "/js/main.js", false, $themeversion);

    if (get_option('fh_logo') == "") {
        //init the default values
        foreach ($allOptions as $option) {
            update_option($option->getOptionId(), $option->getValue());
        }
    }
}
function mytheme_admin() {
    global $themename, $shortname, $subpages, $themeversion,$monkpanel_dir;
    $i = 0;

    if ($_REQUEST['saved'])
        echo '<div id="message" class="updated fade"><p><strong>' . $themename . ' settings saved.</strong></p></div>';
    if ($_REQUEST['reset'])
        echo '<div id="message" class="updated fade"><p><strong>' . $themename . ' settings reset.</strong></p></div>';

    //build the theme options page
    include_once 'monkPanelBuildPage.inc.php';
}
function monk_footer() {
    ?>
<p>
        <?php echo stripslashes(get_option('fh_footer_text')); ?>
</p>
<p style="position: absolute; right: 9px; bottom:4px ; text-align: right">Theme by <a href="http://www.monkify.com">Monkify</a> <a href='http://www.monkify.com' class="icon" ><span class="hidden">Monkify</span></a></p>
    <?php
}

//add the monkpanel
add_action('admin_init', 'mytheme_add_init');
add_action('admin_menu', 'mytheme_add_admin');
?>