<?php
/*
 * @author Ayrton De Craene (http://www.monkify.com)
 * -> ayrton@monkify.com
*/
include_once 'classes/MonkPanelSubPage.php';
include_once 'classes/MonkPanelTab.php';
include_once 'classes/MonkPanelSection.php';

include_once 'classes/MonkPanelCheckbox.php';
include_once 'classes/MonkPanelSelect.php';
include_once 'classes/MonkPanelText.php';
include_once 'classes/MonkPanelTitle.php';


$themename = "Flowhub";
$themeversion = 1.02;
$shortname = "fh";
$monkpanel_dir = get_bloginfo('template_directory') .'/functions/monkpanel';

$colors = array("black","blue","green","grey","orange","pink","purple","red","teal","yellow");

$generalMainHeaderOptions = array(
        new MonkPanelText("Logo Image", "upload your logo (logo.psd) and paste the link to it here", $shortname."_logo", get_bloginfo('stylesheet_directory') .'/images/logo.png'),
);

$generalMainSecHeaderOptions = array(
        new MonkPanelCheckbox("Add advertisement on top?", "If checked, this option will add a 468x60 advertisement slot to your header.", $shortname."_adv"),
        new MonkPanelText("Adv. (468x60) Image", "paste your advertisement image link here", $shortname."_adv_img", get_bloginfo('stylesheet_directory') .'/images/adv_468_filler.png'),
        new MonkPanelText("Adv. (468x60) Link", "paste your advertisement link here", $shortname."_adv_link", get_option('home')),
);

$generalMainFooterOptions = array(
        new MonkPanelText("Footer copyright text", "Enter text used in the right side of the footer. It can be HTML", $shortname."_footer_text", "Powered by <a href='http://wordpress.org/'>WordPress</a>. Icons by <a href='http://www.komodomedia.com/'>Komodo Media</a>.",FALSE)

);

$generalMainRSSFeedOptions = array(
        new MonkPanelText("Feedburner ID", "Feedburner is a Google service that takes care of your RSS feed. Paste your Feedburner ID here to let readers see it in your website", $shortname."_rss", '')
);
$generalMainFaviconOptions = array(
        new MonkPanelText("Custom Favicon", "A favicon is a 16x16 pixel icon that represents your site; paste the URL to a .ico image that you want to use as the image",$shortname."_favicon", get_bloginfo('stylesheet_directory') ."/favicon.ico")
);
$generalOtherGAOptions = array(
        new MonkPanelText("Google Analytics Code", "You can paste your Google Analytics or other tracking code in this box. This will be automatically added to the footer.", $shortname."_ga_code", "", FALSE)
);

$generalOtherCSSOptions = array(
        new MonkPanelText("Custom CSS", FALSE, $shortname."_custom_css", "",FALSE)
);


$generalMainTab = new MonkPanelTab("main", array(        
                new MonkPanelSection("header options", $generalMainHeaderOptions),
                new MonkPanelSection("Secondary Header Options", $generalMainSecHeaderOptions,"right"),
                new MonkPanelSection("footer options",$generalMainFooterOptions),
                new MonkPanelSection("favicon rain", $generalMainFaviconOptions,"right"),
                new MonkPanelSection("rss feed", $generalMainRSSFeedOptions)
        ),"<strong>Welcome to the Monkify Control Panel.</strong> This is a custom extension to the WordPress admin control
    panel. Everything you’ll find in here will be specifically related to the theme you’re using from
    Monkify. This control panel is aimed to simplify a lot of the options, and make it easy to customize
    your theme to suit your needs. Enjoy your theme!");

$generalOtherTab = new MonkPanelTab("custom code", array(
                new MonkPanelSection("Google Analytics Code", $generalOtherGAOptions),
                new MonkPanelSection("Custom CSS",$generalOtherCSSOptions,"right")
        ),""
);

$general = new MonkPanelSubPage("general", array($generalMainTab,$generalOtherTab));

//layout page
$colorsMainLinkOptions = array(
        new MonkPanelText("Links", FALSE, $shortname."_colors_a", "#3CA097"),
        new MonkPanelText("Links:hover", FALSE, $shortname."_colors_a_hover", "#23665f"),
);
$colorsMainBodyOptions = array(
        new MonkPanelText("Body background", FALSE, $shortname."_colors_body", "#EBEADB"),
        new MonkPanelText("Footer background", FALSE, $shortname."_colors_footer", "#CFCFBD"),
);
$colorsMainColorOptions = array(
        new MonkPanelSelect("RSS Color", "Select the color for the rss button", $shortname."_rss_color", $colors, "red"),
        new MonkPanelSelect("Navigation Color", "Navigation Color", $shortname."_nav_color", $colors, "teal"),
        new MonkPanelSelect("Search button Color", "Select the color for the search button", $shortname."_search_color", $colors, "red"),
        new MonkPanelSelect("Newsletter section Color", "Select the color for newsletter section", $shortname."_newsletter_color", $colors, "teal"),
        new MonkPanelSelect("Featured area Color", "Select the color for the featured area", $shortname."_featured_color", $colors, "teal"),
        new MonkPanelSelect("Post Color", "Select the color for the posts", $shortname."_posts_color", $colors, "teal")
);



$colorsMainTab = new MonkPanelTab("main", array(
                new MonkPanelSection("link colors", $colorsMainLinkOptions),
                new MonkPanelSection("color schemes",$colorsMainColorOptions,"right"),
                new MonkPanelSection("site background",$colorsMainBodyOptions),
        ),"Here you can change individual content colors, such as text, links, and borders, along with custom color schemes. Some themes also have custom predefined elements that have a number of color schemes. Which allows you to mix-match elements to create a custom color scheme.");

$colors = new MonkPanelSubPage("colors", array($colorsMainTab));



//putting all the pages into one array
$subpages = array($general,$colors);

if (function_exists('newsletter_embed_form')) {
    $monk_plugins["newsletter"] = "admin.php?page=newsletter/main.php";
}
if (function_exists('sharethis_button')) {
    $monk_plugins["sharethis button"] = "options-general.php?page=sharethis.php";
}
if (function_exists('show_subscription_checkbox')) {
    $monk_plugins["Comments"] = "options-general.php?page=stc-options";
}
if(function_exists('wp125_write_ads')) {
    $monk_plugins["ads 125x15"] = "admin.php?page=wp125/wp125.php";
}
if(function_exists('get_featured_posts')) {
    $monk_plugins["featured posts"] = "options-general.php?page=YAFPP";
}

//init
foreach ($subpages as $subpage) {
    foreach ($subpage->getTabs() as $monk_tab) {
        foreach ($monk_tab->getSections() as $section) {
            foreach ($section->getElements() as $option) {
                $allOptions[] = $option;
            }
        }
    }
}

?>
