<?php
class monk_widget_tab extends WP_Widget {
    function monk_widget_tab() {
        parent::WP_Widget(false, 'Tabs (Flowhub)');
    }
    function widget($args, $instance) {
        $args['title'] = $instance['title'];
        monk_tabs();
    }
    function update($new_instance, $old_instance) {
        return $new_instance;
    }
    function form($instance) {
        echo '<p>this widget will display the tab in the sidebar</p>';
    }
}
function monk_tabs() {
    ?>
<div id="tabs">
    <ul class="tabs">
        <li class="first ui-tabs-selected"><a><span>Top Posts</span></a></li>
        <li><a><span>Comments</span></a></li>
        <li><a><span>Latest Posts</span></a></li>
    </ul>
    <div id="tabtop">&nbsp;</div>
    <div id="tab_top" class="tab">
        <div class="bottom">
            <div class="cont">
                <ul class="small active">
                        <?php getTopPosts();?>
                </ul>
                <ul class="big">
                        <?php getRecentComments(); ?>
                </ul>
                <ul class="small">
                        <?php if(have_posts()) : ?>
                            <?php $latest_posts = new WP_Query('showposts=7'); ?>
                            <?php while ($latest_posts->have_posts()) : $latest_posts->the_post(); ?>
                    <li><a href="<?php the_permalink() ?>"><?php echo trimText(the_title('', '', FALSE), 35); ?><span class="ct"><?php comments_number('0','1','%'); ?></span></a></li>
                            <?php endwhile; ?>
                        <?php endif; ?>
                </ul>
            </div>
        </div>
    </div>
</div>
    <?php
}
function getTopPosts() {
    global $wpdb;
    $request = "SELECT ID, post_title, comment_count FROM $wpdb->posts WHERE comment_count > 0 AND post_status = 'publish' order by comment_count desc LIMIT 0, 7";
    $posts = $wpdb->get_results( $request );
    $output = "";
    foreach ($posts as $post) {
        $output.="<li><a href='".get_permalink($post->ID)."'>".trimText($post->post_title, 35)."<span class='ct'>$post->comment_count</span></a></li>";
    }
    echo $output;
}
function getRecentComments($src_count=4, $src_length=75) {
    global $wpdb;
    $sql = "SELECT DISTINCT ID, post_title, comment_ID, comment_post_ID, comment_author, comment_date_gmt,
			comment_content AS com_excerpt
		FROM $wpdb->comments
		LEFT OUTER JOIN $wpdb->posts ON ($wpdb->comments.comment_post_ID = $wpdb->posts.ID)
		WHERE comment_approved = '1' AND comment_type = '' AND post_password = ''
		ORDER BY comment_date_gmt DESC
		LIMIT $src_count";
    $comments = $wpdb->get_results($sql);
    $output = "";
    foreach ($comments as $comment) {
        if (strlen($comment->comment_author) > 11) {
            $author_min = substr($comment->comment_author, 0, 35) . '...';
        } else {
            $author_min = $comment->comment_author;
        }
        $output .= "<li><span class='element'><a class='author' href='". get_permalink($comment->comment_post_ID) ."#comment-".$comment->comment_ID."'>".$author_min ."</a><span class='text'>". substr(strip_tags($comment->com_excerpt),0,$src_length). "... <a href='".get_permalink($comment->comment_post_ID)."' class='link'>View Post</a></span></span></li>";
    }
    echo $output;
}
?>
